use color_eyre::{eyre::ContextCompat, Result};
use tiny_skia::Pixmap;

use crate::model::image_filter::ImageFilter;

pub fn apply_filter(original: &Pixmap, filter: &ImageFilter) -> Result<Pixmap> {
    let mut result = if let Some(rect) = filter.crop {
        original.clone_rect(*rect).wrap_err_with(|| format!("Invalid crop rect: {}", rect))?
    } else {
        original.clone()
    };

    Ok(result)
}
